#include "utils.h"

__inline __attribute__((always_inline)) void outw(int port, ushort data) {
	__asm __volatile("outw %0,%w1" : : "a" (data), "d" (port));
}
__inline __attribute__((always_inline)) void outb(int port, uchar data) {
	__asm __volatile("outb %0,%w1" : : "a" (data), "d" (port));
}
/*
__inline __attribute__((always_inline)) void insw(int port, 
	void *addr, unsigned char count) {
	asm ("rep insw" : : "c"(count), "d"(port), "D"(addr));
	
   __asm __volatile("rep; insw"
       : "+D" (addr), "+c" (count)
       : "d" (port)
       : "memory");
}
*/
__inline __attribute__((always_inline)) ushort inw(int port) {
	ushort data = 0;
	__asm __volatile("inw %%dx, %%ax" : "=a" (data) : "d" (port));
	return data;
}
__inline __attribute__((always_inline)) uchar inb(int port) {
	uchar data = 0;
	__asm __volatile("inb %%dx, %%al" : "=a" (data) : "d" (port));
	return data;
}

void memcpy(void* dst, void* src, uint size) {
	int i = 0;
	for (; i < size; i++) ((char*) dst)[i] = ((char*) src)[i];
}

#define INS_BUF(data) \
	{ \
		chars ++; \
		buf[i ++] = data; \
		if (i == 127) { \
			buf[i] = 0; \
			scr_printf_x = scr_print(scr_printf_x, scr_printf_y, \
				scr_printf_color, buf); \
			i = 0; \
		} \
	}
	
#define RD_STK() \
	stack[0]; stack ++;

int scr_printf_color = WHITE;
int scr_printf_x = 0;
int scr_printf_y = 0;

void scr_setColor(int color) {
	scr_printf_color = color;
}
void scr_setX(int x) {
	scr_printf_x = x;
}
void scr_setY(int y) {
	scr_printf_y = y;
}

int scr_printf(char* fmt, ...) {
	return scr_xyprintf_stack(fmt, ((int*) &fmt) + 1);
}
int scr_xyprintf(uint x, uint y, int color, char* fmt, ...) {
	scr_printf_color = color;
	scr_printf_x = x;
	scr_printf_y = y;
	return scr_xyprintf_stack(fmt, ((int*) &fmt) + 1);
}
int scr_xyprintf_stack(char* fmt, int *stack) {
	char buf[128];
	int i = 0;
	char c;
	
	int xorig = scr_printf_x;
	uint chars = 0;
	
	while (fmt[0] != 0) {
		c = fmt[0];
		if (c == '\n') {
			INS_BUF(13)
		} else if (c == 8) {
			//Imprimo lo que tengo
			buf[i] = 0;
			scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
				scr_printf_color, buf) - 8;
			i = 0;

			//Borro el ultimo caracter
			buf[0] = ' ';
			buf[1] = 0;
			scr_print(scr_printf_x, scr_printf_y, scr_printf_color, buf);
		} else if (c == '%') {
			fmt ++;
			c = fmt[0];
			if (c == 0) break;
			
			uint num;
			uchar num_str[15];
			int num_i;
			uint r;
			switch (c) {
				case 'C':
					//Cambia el color
					buf[i] = 0;
					scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
						scr_printf_color, buf);
					i = 0;
					
					scr_printf_color = RD_STK();
				break;
				case 'c':
					c = (char) RD_STK();

					//Copy paste de arriba :(
					if (c == 8) {
						//Imprimo lo que tengo
						buf[i] = 0;
						scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
							scr_printf_color, buf) - 8;
						i = 0;

						//Borro el ultimo caracter
						buf[0] = ' ';
						buf[1] = 0;
						scr_print(scr_printf_x, scr_printf_y, scr_printf_color, buf);
					} else {
						INS_BUF(c);
					}
				break;
				case 'd':
					num = RD_STK();
					num_i = 15;
					if (num & 0x80000000) {
						INS_BUF('-');
						num = -num;
					}
					do {
						r = num % 10;
						num = num / 10;
						num_str[-- num_i] = 0x30 + ((uchar) r);
					} while (num != 0);
					for (; num_i < 15; num_i ++) INS_BUF(num_str[num_i]);
				break;
				case 'h':
					num = RD_STK();
					num_i = 15;
					do {
						r = num & 0xF;
						num = num >> 4;
						r += (r > 9) ? 55 : 0x30;
						num_str[-- num_i] = ((uchar) (r));
					} while (num != 0);
					for (; num_i < 15; num_i ++) INS_BUF(num_str[num_i]);
				break;
				case 's':
					//Imprimo lo que tengo
					buf[i] = 0;
					scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
						scr_printf_color, buf);
					i = 0;
					
					//Imprimo el string
					char *str = (char*) RD_STK();
					scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
						scr_printf_color, str);
				break;
				case 'p':
					//Cuenta arg caracteres, si hay menos, llena con espacios
					num = RD_STK();
					while (chars < num) {
						INS_BUF(' ');
					}
					chars = 0;
				break;
				default:
					INS_BUF('%');
					INS_BUF(c);
				break;
			}
		} else {
			INS_BUF(c);
		}
		fmt ++;
	}
	
	buf[i] = 0;
	scr_printf_x = scr_print(scr_printf_x, scr_printf_y, 
		scr_printf_color, buf);
	
	return scr_printf_x - xorig;
}

char *strcat(const char *str1, const char *str2) {
	uint len1 = strlen(str1);
	uint len2 = strlen(str2);
	
	char *ret = (char*) malloc(len1 + len2 + 1);
	uint i;
	uint k = 0;
	for (i = 0; i < len1; i++, k++) {
		ret[k] = str1[i];
	}
	for (i = 0; i < len2; i++, k++) {
		ret[k] = str2[i];
	}
	ret[k] = 0;
	
	return ret;
}

char *strdup(const char *str) {
	uint len = strlen(str);
	char *ret = (char *) malloc(len + 1);
	
	uint i;
	for (i = 0; i <= len; i++) ret[i] = str[i];
	return ret;
}
void strcpy(char *dst, const char *src) {
	while (*src) {
		*dst = *src;
		dst ++; src ++;
	}
	*dst = *src;
}
void strncpy(char *dst, const char *src, int n) {
	while (*src && n > 0) {
		*dst = *src;
		dst ++; src ++;
		n --;
	}
	if (n > 0) *dst = *src;
}

uint strlen(const char *str) {
	char c;
	uint i = 0;
	while ((c=*(str ++))) i++;
	return i;
}

uint strncmp(const char *str1, const char *str2, int size) {
	if (size <= 0) return 0;
	
	uchar c1 = *(str1 ++);
	uchar c2 = *(str2 ++);
	size --;
	while (size > 0 && c1 == c2 && c1 != 0) {
		c1 = *(str1 ++);
		c2 = *(str2 ++);
		size --;
	}
	
	if (c1 == c2) return 0;
	if (c1 == 0) return -1;
	return 1;
}

uint strcmp(const char *str1, const char *str2) {
	uchar c1 = *(str1 ++);
	uchar c2 = *(str2 ++);
	while (c1 == c2 && c1 != 0) {
		c1 = *(str1 ++);
		c2 = *(str2 ++);
	}
	
	if (c1 == 0 && c2 == 0) return 0;
	if (c1 == 0) return -1;
	return 1;
}

int indexOf(const char *str, char chr) {
	uchar c1 = *(str ++);
	int i = 0;
	while (c1 != 0 && c1 != chr) {
		c1 = *(str ++);
		i++;
	}
	
	if (c1 == chr) return i;
	return -1;
}

/* RAND_MAX assumed to be 32767 */
int next = 1;
int rand() {
	if (next == 0) next = 1;
	next = next * 1103515245 + 12345;
	return ((unsigned int) (next / 65536) % 32768);
}

void srand(unsigned int seed) {
	next = seed;
}


char a = 0;
char p = 0;
void dbg () {
	getKeyboardFocus();

	char key = getKeyboardNextChar();
	char code = getKeyboardLastCode();
	a = 1 - a;

	if (p == 0) {
		scr_printf(" ");
		p = 1;
	}

	//char bs[] = {8, 0};
	scr_printf("%c", 8);

	//scr_xyprintf(0,0, GREEN, "<<");
	while (code != 0) {
		//scr_printf("%C\nCodePress: --%h-- CharPress: --%d--", CYAN, code, key);
		scr_printf("%c", key);
		key = getKeyboardNextChar();
		code = getKeyboardLastCode();
	}
	//scr_printf("%C\n>>", GREEN);

	if (a == 0) {
		scr_printf("_");
	} else {
		scr_printf(" ");
	}
}



void releaseDirectoryContentsStruct(directory_contents *dir) {
	char **it = dir->dirs;
	if (it != 0) {
		while (*it != 0) {
			free(*it);
			it ++;
		}
		free(dir->dirs);
		dir->dirs = 0;
	}

	it = dir->files;
	if (it != 0) {
		while (*it != 0) {
			free(*it);
			it ++;
		}
		free(dir->files);
		dir->files = 0;
	}
}