#ifndef UTILS_H
#define UTILS_H

#include "types.h"

#define RGB(r, g, b) ((((r << 8) + g) << 8) + b) << 8
#define WHITE 0xFFFFFF00
#define GRAY 0x7F7F7F00
#define BLACK 0x00000000
#define RED 0xFF000000
#define GREEN 0x00FF0000
#define BLUE 0x0000FF00

#define MAGENTA 0xFF00FF00
#define CYAN 0x00FFFF00
#define YELLOW 0xFFFF0000

/*__inline __attribute__((always_inline)) void insw(int port, void *addr, 
	unsigned char count);*/
#define insw(port, addr, count) \
	asm volatile ("rep insw" : : "c"(count), "d"(port), "D"(addr));
__inline __attribute__((always_inline)) void outb(int port, uchar data);
__inline __attribute__((always_inline)) void outw(int port, ushort data);
__inline __attribute__((always_inline)) uchar inb(int port);
__inline __attribute__((always_inline)) ushort inw(int port);

void scr_setColor(int color);
void scr_setX(int x);
void scr_setY(int y);

void memcpy(void* dst, void* src, uint size);

int scr_xyprintf(uint x, uint y, int color, char* fmt, ...);
int scr_xyprintf_stack(char* fmt, int *stack);
int scr_printf(char* fmt, ...);

int scr_print(uint x, uint y, int color, char* str);

uint strncmp(const char *str1, const char *str2, int size);
uint strcmp(const char *str1, const char *str2);
char *strcat(const char *str1, const char *str2);
int indexOf(const char *str, char chr);
void strncpy(char *dst, const char *src, int n);
void strcpy(char *dst, const char *src);
char *strdup(const char *str);
uint strlen(const char *str);

void srand(unsigned int seed);
int rand();

void *malloc(unsigned int size);
void free(void* address);

void dbg();

void getKeyboardFocus();
char getKeyboardNextCode();
char getKeyboardNextChar();
char getKeyboardLastCode();
char getKeyboardLastChar();



typedef struct str_directory {
	char **files;
	char **dirs;
} directory_contents;
void releaseDirectoryContentsStruct(directory_contents *dir);
int getDirectoryContents(const char *path, directory_contents *dir);
int runFiles(const char *file1, const char *file2);
int runFile(const char *file);

#endif