#include "gdt.h"

gdt_entry gdt[GDT_COUNT] = {
	/* Descriptor nulo*/
	(gdt_entry){(unsigned int) 0x00000000, (unsigned int) 0x00000000 },
	(gdt_entry){		//Segmento de codigo de supervisor
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0xA,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x0,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x1,			//db:1;
		(unsigned char) 0x1,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		},
	(gdt_entry){		//Segmento de datos de supervisor
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0x2,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x0,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x1,			//db:1;
		(unsigned char) 0x1,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		},
	(gdt_entry){		//Segmento de codigo para 16 bits
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0xA,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x0,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x0,			//db:1;
		(unsigned char) 0x0,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		},
	(gdt_entry){		//Segmento de datos para 16 bits
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0x2,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x0,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x0,			//db:1;
		(unsigned char) 0x0,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		},
	(gdt_entry){		//Segmento de codigo de usuario
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0xA,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x3,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x1,			//db:1;
		(unsigned char) 0x1,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		},
	(gdt_entry){		//Segmento de datos de usuario
		(unsigned short) 0xFFFF,		//limit_0_15
		(unsigned short) 0x0000,		//base_0_15
		(unsigned char) 0x00,			//base_23_16;
		(unsigned char) 0x2,			//type:4;
		(unsigned char) 0x1,			//s:1;
		(unsigned char) 0x3,			//dpl:2;
		(unsigned char) 0x1,			//p:1;
		(unsigned char) 0xF,			//limit_16_19:4;
		(unsigned char) 0x0,			//avl:1;
		(unsigned char) 0x0,			//l:1;
		(unsigned char) 0x1,			//db:1;
		(unsigned char) 0x1,			//g:1;
		(unsigned char) 0x00			//base_31_24;
		}
};

gdt_descriptor GDT_DESC = {sizeof(gdt)-1, (unsigned int)&gdt};

unsigned int freeGdtEntryIndex[GDT_COUNT-5];
unsigned int nextFreeGdtId;
void inicializar_gdt() {
	int i = 0;
	for(; i < GDT_COUNT - 5; i ++) {
		freeGdtEntryIndex[i] = i + 5;
	}
	nextFreeGdtId = GDT_COUNT - 6;
}
gdt_entry *entradaLibreGDT() {
	if (nextFreeGdtId < 0) return 0;
	return &(gdt[freeGdtEntryIndex[nextFreeGdtId --]]);
}
void releaseSegment(gdt_entry *gdt_e) {
	unsigned int recycleId = ((unsigned int) gdt_e - ((unsigned int) gdt)) / sizeof(gdt_entry);
	freeGdtEntryIndex[++nextFreeGdtId] = recycleId;
}