BITS 16

%include "macros/graphics.mac"

%define KORG 0x1200

global start
extern GDT_DESC
extern gdt
extern tsss
extern IDT_DESC
extern inicializar_idt
extern inicializar_mmu
extern inicializar_tareas
extern inicializar_scheduler
extern crear_proceso

extern resetear_pic
extern habilitar_pic

extern start_vesa
extern check_hdd
extern read_hdd
extern init_fat16
extern k_initialize

extern scr_printf

;Aca arranca todo, en el primer byte.
start:
		cli			;no me interrumpan por ahora
		xor ax, ax
		mov al, 0x13
		int 0x10
		
		jmp 	bienvenida


bienvenida:
		;Habilitar A20
		call habilitar_A20
		
		;Inicializar GDT
		lgdt [GDT_DESC_hack]
		
		;Pasar a modo protegido
		mov eax, cr0
		or eax, 1
		mov cr0, eax
		
		jmp 0x08:kernel_gdt

;Por algun motivo, GDT_DESC a veces queda fuera de los
;16 bits de direccionamiento, por lo que tuve que hacer
;este hack usando una gdt definida mas abajo con dos
;segmentos, saltar a 32 bits, y recien ahi hacer el lgdt
;que corresponde
ALIGN 16
GDT_DESC_hack:
	dw 191
	dd GDT_DATA_hack
ALIGN 8
GDT_DATA_hack:
	dd 0, 0 					;segmento nulo
	dd 0x0000ffff, 0x00cf9b00	;segmento de codigo
	dd 0x0000ffff, 0x00cf9300	;segmento de datos



BITS 32
kernel_gdt:
		mov ax, 0x10
		mov ds, ax
		mov es, ax
		mov fs, ax
		mov gs, ax
		mov ss, ax
		lgdt [GDT_DESC]
		jmp 0x08:modo_protegido


sec_msg: db '[%s]', 0
modo_protegido:
		mov esp, 0x40000
		mov ebp, 0x40000
		
		;Activo SSE y PSE
		mov eax, cr4
		or eax, 310h
		mov cr4, eax
		
		;Activa modo grafico usando VESA
		call start_vesa
		
		;Cargo descriptor de interrupciones
		call inicializar_idt
		lidt [IDT_DESC]

		;Habilitar paginacion
		call inicializar_mmu
		mov eax, cr0
		or eax, 0x80000002	;bit 1 en ON
		and eax, ~4		;bit 2 en OFF
		mov cr0, eax
		
		;Configuro el driver de disco
		call check_hdd
		test al, al
		jnz .no_hdd
		
		call init_fat16
		test al, al
		jnz .no_fs
		
		;jmp $

		;Inicializo el driver del teclado
		call k_initialize
		
		;Setea las interrupciones externas
		call resetear_pic
		call habilitar_pic

		;Inicializo las tareas
		call inicializar_tareas
		
		push dword 0x1A000
		call inicializar_scheduler
		add esp, 4
		mov [jmp_task + 4], ax
		
		push dword 8
		push dword 0x15000
		;call crear_proceso
		add esp, 4
		push dword 0x1D000
		;call crear_proceso
		add esp, 4
		
		;push dword 0x15000
		;call crear_proceso
		;add esp, 4
		;push dword 0x16000
		;call crear_proceso
		;add esp, 4
		add esp, 4
		
		;xchg bx, bx
		jmp far [jmp_task]

		jmp $
	
	.no_hdd:
		push dword RED
		push dword YELLOW
		push dword hdd_msg
		call scr_printf
		add esp, 12
		
		jmp $
	.no_fs:
		push dword RED
		push dword YELLOW
		push dword fs_msg
		call scr_printf
		add esp, 12
		
		jmp $
	hdd_msg: db '%C[HDD]%C HDD driver off!'
	fs_msg: db '%C[FS]%C FAT16 driver off!'
jmp_task: dd 0
	dw 0

%include "kernel/a20.asm"
