#include "../common/types.h"
#include "../common/utils.h"

#define PIC1_PORT 0x20
#define PIC2_PORT 0xA0

__inline __attribute__((always_inline)) void fin_intr_pic1(void) { outb(0x20, 0x20); } 
__inline __attribute__((always_inline)) void fin_intr_pic2(void) { outb(0x20, 0x20); outb(0xA0, 0x20); } 


void setTMR0(unsigned int freq) {
	//Setea el TIMER0
	outb(0x43, 0x34);
	
	if (freq < 18) freq = 18;
	if (freq > 1193181) freq = 1193181;
	unsigned int reloadValue = (3579545 / freq);
	unsigned int rem = (3579545 % freq);
	if (rem >= 3579545 / 2) reloadValue ++;
	rem = reloadValue % 3;
	reloadValue /= 3;
	if (rem >= 3 / 2) reloadValue ++;
	
	outb(0x40, (unsigned char) reloadValue);
	outb(0x40, (unsigned char) (reloadValue >> 8));
}
void resetear_pic() {
	outb(PIC1_PORT+0, 0x11); /* IRQs activas x flanco, cascada, y ICW4 */
	outb(PIC1_PORT+1, 0x20); /* Addr */
	outb(PIC1_PORT+1, 0x04); /* PIC1 Master, Slave ingresa Int.x IRQ2 */
	outb(PIC1_PORT+1, 0x01); /* Modo 8086 */
	outb(PIC1_PORT+1, 0xFF); /* Enmasca todas! */

	outb(PIC2_PORT+0, 0x11); /* IRQs activas x flanco, cascada, y ICW4 */
	outb(PIC2_PORT+1, 0x28); /* Addr */
	outb(PIC2_PORT+1, 0x02); /* PIC2 Slave, ingresa Int x IRQ2 */
	outb(PIC2_PORT+1, 0x01); /* Modo 8086 */
	outb(PIC2_PORT+1, 0xFF); /* Enmasca todas! */
	
	setTMR0(1000);
}

void habilitar_pic() {
	outb(PIC1_PORT+1, 0x00);
	outb(PIC2_PORT+1, 0x00);
}

void deshabilitar_pic() {
	outb(PIC1_PORT+1, 0xFF);
	outb(PIC2_PORT+1, 0xFF);
}

