#ifndef __SCHED_H__
#define __SCHED_H__

#define CANT_TAREAS 16
#define IDLE_PID 0
#define NULL 0

unsigned short crear_proceso(unsigned int cargar_desde, unsigned int pages);
unsigned short inicializar_scheduler();
unsigned short proximo_indice();
void switch_task_return();
void forced_switch_task();
void kill_current_task();
unsigned int act_pid;

void resetWakingKeyCode();
unsigned short wakingKeyCode();

void warnKeyPress(unsigned char keyCode);
void assignKeyPress(unsigned char keyCode, unsigned short task);
void setTaskActiveTime(unsigned int time);
void sleepTask(unsigned int time);
void waitTask(unsigned int time);
void doStep();
void sleep();

void s_getKeyboardFocus();
char s_getKeyboardNextCode();
char s_getKeyboardNextChar();
char s_getKeyboardLastCode();
char s_getKeyboardLastChar();

void s_specialKeyPressed();

typedef struct task_struct {
	unsigned int fxData[128] __attribute__((aligned(16)));
	unsigned short gdtOffset;
	unsigned char fxValid;
	unsigned short pid;
	
	unsigned char delete_later;
	unsigned char keyCode;
	unsigned int sleepTime;
	unsigned int waitTime;
	unsigned int activeTime;
	unsigned int parent_pid;

	unsigned int dir;
	unsigned int pages;
	unsigned int stack_page;
} taskStr;

typedef struct task_list_struct task_list;
struct task_list_struct {
	unsigned int recycleId;
	task_list *prev;
	task_list *next;
	taskStr tsk;
};

#endif
