BITS 32

extern IDT_DESC
global realmode_addr
global realmode_ret
global to_realmode
global to_protectedmode

realmode_addr: dd 0
realmode_ret: dd 0

real_sp:
	%rep 0x1000
		dw 0
	%endrep
backup_esp:
	dd 0

idt_real: 
	dw 0x3ff 
	dd 0

backup_cr3:
	dd 0
backup_cr0:
	dd 0

to_realmode:
	;Guarda CR3
	mov eax, cr3
	mov [backup_cr3], eax
	
	;Deshabilita paginacion
	mov eax, cr0
	mov [backup_cr0], eax
	and eax, 0x7FFFFFF
	mov cr0, eax
	
	;Guarda el ESP y lo cambia
	mov [backup_esp], esp
	lea esp, [backup_esp]
	
	;Cambia a un CS de 16 bits
	xor eax, eax
	mov cr3, eax
	jmp 0x18:.rm_16_1
	
BITS 16
.rm_16_1:
	;Cambia los selectores a 16 bits
	mov ax, 0x20
	mov ds, ax
	mov ss, ax
	mov es, ax
	mov fs, ax
	
	;Carga la IDT del modo real
	lidt [idt_real]
	
	;Deshabilita el bit PE
	mov eax, cr0
	and eax, 0xFFFFFFFE
	mov cr0, eax
	jmp 0x00:.rm_16
	
.rm_16:
	;Deja los selectores en 0
	xor ax, ax
	mov ds, ax
	mov ss, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	
	jmp [realmode_addr]
	

to_protectedmode:
	;Activa el bit PE
	mov eax, cr0
	or ax, 1
	mov cr0, eax
	
	jmp 0x08:.text_32

BITS 32
.text_32:
	;Setea los selectores
	mov ax, 0x10
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	mov ss, ax
	
	;Recupera el ESP
	mov esp, [backup_esp]
	
	;Recarga la IDT
	lidt [IDT_DESC]
	
	;Recupera el CR3
	mov eax, [backup_cr3]
	mov cr3, eax
		
	;Deja las cosas como estaban
	mov eax, [backup_cr0]
	mov cr0, eax
	
	jmp [realmode_ret]
	