#include "../../common/utils.h"
#include "conway.h"
#include "conway_utils.h"
#include "conway_fn.h"

void set_at(unsigned char *board, int x, int y, unsigned char v) {
	if (x > HWID * 2) return;
	if (y > HEI) return;

	x += 2;
	y ++;
	
	unsigned int px = x >> 1;
	
	unsigned char m = 0xF0;
	v = (v > 0) ? 1 : 0;
	if (px << 1 != x) {
		v = v << 4;
		m = m >> 4;
	}
	
	unsigned int pos = (HWID + 2) * y + px;
	board[pos] &= m;
	board[pos] |= v;
}

unsigned char get_at(unsigned char *board, int x, int y) {
	x += 2;
	y ++;
	
	unsigned int px = x >> 1;
	
	unsigned char v = 1;
	if (px << 1 != x) {
		v = v << 4;
	}
	
	unsigned int pos = (HWID + 2) * y + px;
	return (board[pos] & v) != 0;
}

void setup_game() {
	SCREEN_TOP = 24;
	SCREEN_BOTTOM = 24;
	evolutions = 0;
	
//	HWID = getScreenWidth() >> 2;
//	HEI = (getScreenHeight() * 3) >> 2;

	HWID = getScreenWidth() >> 1;
	HEI = (getScreenHeight() >> 1) - (SCREEN_BOTTOM + SCREEN_TOP);
	
	//asm("xchg %bx, %bx");
	states = (unsigned char *) malloc((HWID + 2) * (HEI + 2) * 2);
	//asm("xchg %bx, %bx");

	actState = 0;
	fill_with_zero(states, (HWID + 2) * (HEI + 2) * 2);
	state[0] = states;
	state[1] = states + (HWID + 2) * (HEI + 2);
	
	unsigned char gun[36][9];
	fill_with_zero((unsigned char *) &gun, 9 * 36);
	
	/*
	gun[0][4] = 1;
	gun[1][4] = 1;
	gun[0][5] = 1;
	gun[1][5] = 1;
	
	gun[10][4] = 1;
	gun[10][5] = 1;
	gun[10][6] = 1;
	
	gun[11][3] = 1;
	gun[11][7] = 1;
	
	gun[12][2] = 1;
	gun[12][8] = 1;
	gun[13][2] = 1;
	gun[13][8] = 1;
	
	gun[14][5] = 1;
	
	gun[15][3] = 1;
	gun[15][7] = 1;
	
	gun[16][4] = 1;
	gun[16][5] = 1;
	gun[16][6] = 1;
	
	gun[17][5] = 1;
	
	gun[20][2] = 1;
	gun[20][3] = 1;
	gun[20][4] = 1;
	
	gun[21][2] = 1;
	gun[21][3] = 1;
	gun[21][4] = 1;
	
	gun[22][1] = 1;
	gun[22][5] = 1;
	
	gun[24][0] = 1;
	gun[24][1] = 1;
	gun[24][5] = 1;
	gun[24][6] = 1;
	
	gun[34][2] = 1;
	gun[34][3] = 1;
	gun[35][2] = 1;
	gun[35][3] = 1;
	
	int i = 0;
	int j = 0;
	for (i = 0; i < 36; i++) {
		for (j = 0; j < 9; j++) {
			set_at(state[0], i, j, gun[i][j]);
		}
	}
	//*/
	
	/*
	set_at(state[0], 1, 0, 1);
	set_at(state[0], 2, 1, 1);
	set_at(state[0], 0, 2, 1);
	set_at(state[0], 1, 2, 1);
	set_at(state[0], 2, 2, 1);
	//*/
	
	/*
	set_at(state[0], 28, 30, 1);
	set_at(state[0], 28, 31, 1);
	set_at(state[0], 29, 30, 1);
	set_at(state[0], 29, 31, 1);
	//*/

	int i;
	unsigned char *stateArr[HEI];
	stateArr[0] = states;
	for (i = 1; i < HEI; i ++) {
		stateArr[i] = stateArr[i - 1] + HWID+2;
	}
	
	//*
	stateArr[39][39] = 16; 
	stateArr[39][40] = 1; 
	stateArr[40][37] = 16; 
	stateArr[40][38] = 17; 
	stateArr[40][39] = 1; 
	stateArr[40][40] = 17; 
	stateArr[41][37] = 16; 
	stateArr[41][38] = 17; 
	stateArr[41][39] = 17; 
	stateArr[41][40] = 1; 
	stateArr[42][38] = 17; 
	stateArr[42][39] = 17; 
	stateArr[46][47] = 17; 
	stateArr[47][45] = 17; 
	stateArr[47][46] = 17; 
	stateArr[47][47] = 16; 
	stateArr[47][48] = 1; 
	stateArr[47][114] = 16; 
	stateArr[47][115] = 17; 
	stateArr[47][116] = 1; 
	stateArr[47][154] = 1; 
	stateArr[47][155] = 16; 
	stateArr[48][45] = 17; 
	stateArr[48][46] = 17; 
	stateArr[48][47] = 17; 
	stateArr[48][114] = 17; 
	stateArr[48][115] = 17; 
	stateArr[48][116] = 17; 
	stateArr[48][156] = 1; 
	stateArr[48][159] = 16; 
	stateArr[48][160] = 1; 
	stateArr[49][45] = 16; 
	stateArr[49][46] = 17; 
	stateArr[49][47] = 1; 
	stateArr[49][109] = 17; 
	stateArr[49][110] = 17; 
	stateArr[49][114] = 17; 
	stateArr[49][115] = 17; 
	stateArr[49][116] = 16; 
	stateArr[49][117] = 1; 
	stateArr[49][154] = 1; 
	stateArr[49][156] = 1; 
	stateArr[49][158] = 16; 
	stateArr[49][159] = 1; 
	stateArr[49][160] = 17; 
	stateArr[50][83] = 17; 
	stateArr[50][84] = 1; 
	stateArr[50][108] = 16; 
	stateArr[50][109] = 17; 
	stateArr[50][110] = 17; 
	stateArr[50][111] = 1; 
	stateArr[50][116] = 17; 
	stateArr[50][154] = 16; 
	stateArr[50][155] = 17; 
	stateArr[50][156] = 1; 
	stateArr[50][158] = 16; 
	stateArr[50][159] = 17; 
	stateArr[50][160] = 1; 
	stateArr[51][82] = 16; 
	stateArr[51][83] = 17; 
	stateArr[51][84] = 17; 
	stateArr[51][108] = 16; 
	stateArr[51][109] = 17; 
	stateArr[51][110] = 1; 
	stateArr[51][111] = 17; 
	stateArr[51][159] = 17; 
	stateArr[52][50] = 17; 
	stateArr[52][51] = 17; 
	stateArr[52][82] = 16; 
	stateArr[52][83] = 17; 
	stateArr[52][84] = 16; 
	stateArr[52][85] = 1; 
	stateArr[52][88] = 17; 
	stateArr[52][110] = 16; 
	stateArr[52][111] = 1; 
	stateArr[53][49] = 16; 
	stateArr[53][50] = 17; 
	stateArr[53][51] = 17; 
	stateArr[53][52] = 1; 
	stateArr[53][84] = 17; 
	stateArr[53][87] = 1; 
	stateArr[53][89] = 16; 
	stateArr[54][49] = 16; 
	stateArr[54][50] = 17; 
	stateArr[54][51] = 1; 
	stateArr[54][52] = 17; 
	stateArr[54][90] = 1; 
	stateArr[54][119] = 17; 
	stateArr[54][120] = 17; 
	stateArr[54][121] = 17; 
	stateArr[54][158] = 16; 
	stateArr[55][51] = 16; 
	stateArr[55][52] = 1; 
	stateArr[55][87] = 1; 
	stateArr[55][90] = 1; 
	stateArr[55][118] = 16; 
	stateArr[55][121] = 16; 
	stateArr[55][158] = 16; 
	stateArr[55][159] = 1; 
	stateArr[56][87] = 16; 
	stateArr[56][88] = 17; 
	stateArr[56][89] = 17; 
	stateArr[56][90] = 1; 
	stateArr[56][118] = 16; 
	stateArr[56][121] = 16; 
	stateArr[56][159] = 17; 
	stateArr[57][119] = 1; 
	stateArr[57][121] = 1; 
	stateArr[57][158] = 16; 
	stateArr[57][159] = 1; 
	stateArr[58][73] = 17; 
	stateArr[58][74] = 1; 
	stateArr[58][120] = 1; 
	stateArr[59][73] = 1; 
	stateArr[59][74] = 1; 
	stateArr[59][120] = 17; 
	stateArr[60][73] = 17; 
	stateArr[60][74] = 1; 
	stateArr[60][119] = 16; 
	stateArr[60][120] = 17; 
	stateArr[60][121] = 1; 
	stateArr[61][80] = 16; 
	stateArr[61][81] = 17; 
	stateArr[61][82] = 16; 
	stateArr[61][83] = 17; 
	stateArr[61][84] = 16; 
	stateArr[61][85] = 17; 
	stateArr[61][86] = 16; 
	stateArr[61][87] = 17; 
	stateArr[61][90] = 17; 
	stateArr[61][119] = 16; 
	stateArr[61][120] = 1; 
	stateArr[61][121] = 17; 
	stateArr[62][73] = 17; 
	stateArr[62][74] = 1; 
	stateArr[62][89] = 17; 
	stateArr[62][90] = 16; 
	stateArr[62][91] = 1; 
	stateArr[62][120] = 16; 
	stateArr[62][121] = 1; 
	stateArr[62][159] = 16; 
	stateArr[62][160] = 1; 
	stateArr[63][73] = 1; 
	stateArr[63][74] = 1; 
	stateArr[63][89] = 17; 
	stateArr[63][90] = 17; 
	stateArr[63][109] = 17; 
	stateArr[63][115] = 17; 
	stateArr[63][116] = 17; 
	stateArr[63][117] = 17; 
	stateArr[63][150] = 16; 
	stateArr[63][151] = 1; 
	stateArr[63][158] = 16; 
	stateArr[63][159] = 1; 
	stateArr[63][160] = 17; 
	stateArr[64][73] = 17; 
	stateArr[64][74] = 1; 
	stateArr[64][89] = 17; 
	stateArr[64][90] = 1;
	stateArr[64][107] = 17; 
	stateArr[64][108] = 17; 
	stateArr[64][109] = 16; 
	stateArr[64][110] = 1; 
	stateArr[64][114] = 16; 
	stateArr[64][117] = 16; 
	stateArr[64][150] = 17; 
	stateArr[64][151] = 17; 
	stateArr[64][158] = 16; 
	stateArr[64][159] = 17; 
	stateArr[64][160] = 1; 
	stateArr[65][89] = 16; 
	stateArr[65][107] = 17; 
	stateArr[65][108] = 17; 
	stateArr[65][109] = 17; 
	stateArr[65][117] = 16; 
	stateArr[65][150] = 17; 
	stateArr[65][151] = 16; 
	stateArr[65][152] = 1; 
	stateArr[65][159] = 17; 
	stateArr[66][40] = 17; 
	stateArr[66][88] = 16; 
	stateArr[66][90] = 16; 
	stateArr[66][107] = 16; 
	stateArr[66][108] = 17; 
	stateArr[66][109] = 1; 
	stateArr[66][114] = 16;
	stateArr[66][117] = 1; 
	stateArr[66][151] = 17; 
	stateArr[67][39] = 16; 
	stateArr[67][40] = 17; 
	stateArr[67][41] = 1; 
	stateArr[67][52] = 16; 
	stateArr[67][53] = 17; 
	stateArr[67][54] = 17; 
	stateArr[67][91] = 1; 
	stateArr[67][115] = 16; 
	stateArr[67][116] = 1; 
	stateArr[68][31] = 16; 
	stateArr[68][32] = 1; 
	stateArr[68][39] = 16; 
	stateArr[68][40] = 1; 
	stateArr[68][41] = 17; 
	stateArr[68][52] = 1; 
	stateArr[68][54] = 16; 
	stateArr[68][88] = 16; 
	stateArr[68][91] = 1;
	stateArr[69][29] = 16; 
	stateArr[69][30] = 17; 
	stateArr[69][31] = 1; 
	stateArr[69][32] = 17; 
	stateArr[69][40] = 16; 
	stateArr[69][41] = 1; 
	stateArr[69][54] = 16; 
	stateArr[69][84] = 17; 
	stateArr[69][89] = 17; 
	stateArr[69][90] = 17; 
	stateArr[69][91] = 1; 
	stateArr[70][29] = 16; 
	stateArr[70][30] = 17; 
	stateArr[70][31] = 17; 
	stateArr[70][32] = 1; 
	stateArr[70][52] = 1; 
	stateArr[70][54] = 1; 
	stateArr[70][82] = 16; 
	stateArr[70][83] = 17; 
	stateArr[70][84] = 16; 
	stateArr[70][85] = 1; 
	stateArr[71][30] = 17; 
	stateArr[71][31] = 17; 
	stateArr[71][53] = 1; 
	stateArr[71][82] = 16; 
	stateArr[71][83] = 17; 
	stateArr[71][84] = 17; 
	stateArr[72][83] = 17; 
	stateArr[72][84] = 1; 
	stateArr[96][114] = 17; 
	stateArr[96][115] = 17; 
	stateArr[96][154] = 1; 
	stateArr[96][155] = 16; 
	stateArr[97][113] = 16; 
	stateArr[97][114] = 17; 
	stateArr[97][115] = 17;
	stateArr[97][116] = 1; 
	stateArr[97][156] = 1; 
	stateArr[97][159] = 16; 
	stateArr[97][160] = 1; 
	stateArr[98][113] = 16; 
	stateArr[98][114] = 17; 
	stateArr[98][115] = 1; 
	stateArr[98][116] = 17; 
	stateArr[98][154] = 1; 
	stateArr[98][156] = 1; 
	stateArr[98][158] = 16; 
	stateArr[98][159] = 1; 
	stateArr[98][160] = 17; 
	stateArr[99][115] = 16; 
	stateArr[99][116] = 1; 
	stateArr[99][154] = 16; 
	stateArr[99][155] = 17; 
	stateArr[99][156] = 1; 
	stateArr[99][158] = 16; 
	stateArr[99][159] = 17; 
	stateArr[99][160] = 1; 
	stateArr[100][159] = 17; 
	stateArr[103][118] = 16; 
	stateArr[103][119] = 17; 
	stateArr[103][120] = 17; 
	stateArr[103][121] = 1; 
	stateArr[103][158] = 16; 
	stateArr[104][118] = 1; 
	stateArr[104][121] = 1; 
	stateArr[104][158] = 16; 
	stateArr[104][159] = 1; 
	stateArr[105][118] = 1; 
	stateArr[105][121] = 1; 
	stateArr[105][159] = 17; 
	stateArr[106][118] = 16; 
	stateArr[106][120] = 16; 
	stateArr[106][158] = 16; 
	stateArr[106][159] = 1; 
	stateArr[107][119] = 16; 
	stateArr[108][119] = 16; 
	stateArr[108][120] = 1; 
	stateArr[109][119] = 17; 
	stateArr[109][120] = 17; 
	stateArr[110][119] = 17; 
	stateArr[110][120] = 16; 
	stateArr[110][121] = 1; 
	stateArr[111][120] = 17; 
	stateArr[111][159] = 16; 
	stateArr[111][160] = 1; 
	stateArr[112][114] = 16; 
	stateArr[112][115] = 17; 
	stateArr[112][116] = 17; 
	stateArr[112][117] = 1; 
	stateArr[112][158] = 16; 
	stateArr[112][159] = 1; 
	stateArr[112][160] = 17; 
	stateArr[113][114] = 1; 
	stateArr[113][117] = 1; 
	stateArr[113][150] = 16; 
	stateArr[113][151] = 1; 
	stateArr[113][158] = 16; 
	stateArr[113][159] = 17; 
	stateArr[113][160] = 1; 
	stateArr[114][117] = 1; 
	stateArr[114][149] = 16; 
	stateArr[114][150] = 1; 
	stateArr[114][151] = 17; 
	stateArr[114][159] = 17; 
	stateArr[115][114] = 1; 
	stateArr[115][116] = 16; 
	stateArr[115][149] = 16; 
	stateArr[115][150] = 17; 
	stateArr[115][151] = 1; 
	stateArr[116][115] = 17; 
	stateArr[116][150] = 17; 
	//*/
}

void game_cycle() {
	//asm("xchg %bx, %bx");
	while (1) {
		//Imprime titulo
		scr_xyprintf(screen_x_offset(), screen_y_offset() - SCREEN_TOP, GRAY, 
			"Conway Game of Life - %C%s\n\n", 
				is_sse() ? RED : BLUE, 
				is_sse() ? "SSE" : "GPR");
		
		//Dibuja el estado actual
		draw_state(state[actState], HWID, HEI, screen_x_offset(), screen_y_offset());
		
		//Evoluciona al siguiente estado
		conway_step(state[actState], state[1 - actState], HWID, HEI);
		actState = 1 - actState;
		evolutions ++;
		
		//Imprime cantidad de evoluciones
		scr_xyprintf(screen_x_offset(), screen_y_offset() + HEI, CYAN, 
			"Evoluciones: %d\n\n", evolutions);
		
		//int_wait(1000);
		//asm("xchg %bx, %bx");
		//int_sleep(1000);
	}
}
