%include "macros/graphics.mac"

global draw_state
global fill_with_zero
global int_sleep
global int_wait

extern evolutions
extern is_sse

%define ds_state ebp + 8
%define ds_wid ebp + 12
%define ds_hei ebp + 16
%define ds_offx ebp + 20
%define ds_offy ebp + 24

scr_wid: dd 0
scr_hei: dd 0

;void draw_state(unsigned char *state, unsigned int wid, unsigned int hei, unsigned int offX, unsigned int offY);
draw_state:
	push ebp
	mov ebp, esp
	
	push esi
	push edi
	push ebx
	
.cont:
	mov esi, [ds_state]
	mov eax, [ds_wid]
	mov ebx, [ds_hei]
		
	lea esi, [esi + eax + 3]
	cont_loop:
		DRAW_BYTE esi, [ds_wid], 4, [ds_offx], [ds_offy], 3, 0, 0xFF
		mov eax, [ds_wid]
		lea esi, [esi + eax + 2]
		inc dword [ds_offy]
		dec ebx
		jnz cont_loop
	
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret
	

;void fill_with_zero(unsigned char *arr, unsigned int size)
fill_with_zero:
	push ebp
	mov ebp, esp
	
	mov eax, [ebp + 8]			;eax = arr
	mov ebx, [ebp + 12]			;ebx = size
	mov ecx, ebx
	shr ecx, 4					;ecx = size / 16
	
	test ecx, ecx				;if (size / 16 == 0) return
	jz .fill_with_zero_sse_loop_post
	
	pxor xmm0, xmm0
	.fill_with_zero_sse_loop:
		movdqu [eax], xmm0
		add eax, 16
		
	loop .fill_with_zero_sse_loop
.fill_with_zero_sse_loop_post:
	
	mov cl, bl
	and cl, 1111b				;ecx = (size % 16)
	jz .fill_with_zero_ret		;if (size % 16 == 0) return
	
	xor bl, bl
	.fill_with_zero_reg_loop:
		mov [eax], bl
		inc eax
		
	loop .fill_with_zero_reg_loop
	
.fill_with_zero_ret:
	pop ebp
	
	ret


	
int_sleep:
	mov eax, [esp + 4]
	int 67
	ret
	
int_wait:
	mov eax, [esp + 4]
	int 68
	ret
