#include "../conway.h"
#include "../conway_utils.h"
#include "../conway_fn.h"

void conway_step(unsigned char *oldState, unsigned char *newState, unsigned int wid, unsigned int hei) {
	unsigned int rwid = wid * 2;
	unsigned char s, sact;
	int x, y;
	
	for (y = 0; y < hei; y++) {
		for (x = 0; x < rwid; x++) {
			sact = get_at(oldState, x, y);
			
			s = get_at(oldState, x-1, y-1);
			s += get_at(oldState, x, y-1);
			s += get_at(oldState, x+1, y-1);
			s += get_at(oldState, x-1, y);
			s += get_at(oldState, x+1, y);
			s += get_at(oldState, x-1, y+1);
			s += get_at(oldState, x, y+1);
			s += get_at(oldState, x+1, y+1);
			
			set_at(newState, x, y, (sact | s) == 3 );
		}
	}
}

int screen_x_offset() {
	return 0;
	//return HWID * 2;
}
int screen_y_offset() {
	return HEI + 2*SCREEN_TOP + SCREEN_BOTTOM;
	//return 0;
}

int is_sse() {
	return 0;
}
