
%macro xmm01I 4
	%if %3 == %1
		movdqu %4, %1
		movdqu %3, %2
	%else
		movdqu %3, %2
		movdqu %4, %1
	%endif
	psllq %3, 4
	psrlq %4, 4
	por %3, %4
%endmacro

global screen_y_offset
global screen_x_offset
global conway_step
global is_sse

extern SCREEN_TOP

;int screen_x_offset();
screen_x_offset:
	mov eax, 0
	ret
	
screen_y_offset:
	mov eax, [SCREEN_TOP]
	ret
	
is_sse:
	mov eax, 1
	ret

;void conway_step(unsigned char *oldState, unsigned char *newState, unsigned int wid, unsigned int hei)
%define cs_oldState (ebp + 8)
%define cs_newState (ebp + 12)
%define cs_wid (ebp + 16)
%define cs_hei (ebp + 20)
%define cs_var_wid (ebp - 4)

conway_step:
	push ebp
	mov ebp, esp
	sub esp, 4
	push edi
	push esi
	push ebx
	
	mov esi, [cs_oldState]
	mov edi, [cs_newState]
	mov eax, [cs_wid]
	mov ebx, [cs_hei]
	
	lea esi, [esi]					
	
	mov [cs_var_wid], eax
	shr dword [cs_var_wid], 4			;var_wid = wid / 16
	add eax, 2						;eax = wid + 2 = row_size
	
	sub edi, eax
	inc edi							;edi = -(wid + 2) + 1
	
	.conway_step_col_loop:
		mov ecx, ebx
		mov edx, eax				;edx = wid
		
		movdqu xmm0, [esi]
		movdqu xmm7, [esi + 1]			;xmm7 = xmm01I
		xmm01I xmm0, xmm7, xmm0, xmm2	;xmm0 = 'xmm0'
		
		movdqu xmm1, [esi + 2]
		xmm01I xmm7, xmm1, xmm1, xmm2	;xmm1 = 'xmm1'
		
		paddb xmm7, xmm0
		paddb xmm7, xmm1				;xmm7 = xmm0 + xmm01I + xmm1
		
		movdqu xmm0, [esi + edx]
		movdqu xmm5, [esi + edx + 1]	;xmm5 = xmm01I
		xmm01I xmm0, xmm5, xmm0, xmm2	;xmm0 = 'xmm0'
		
		movdqu xmm1, [esi + edx + 2]
		xmm01I xmm5, xmm1, xmm1, xmm2	;xmm1 = 'xmm1'
		
		movdqu xmm6, xmm0
		paddb xmm6, xmm1				;xmm6 = xmm0 + xmm1
		
		.conway_step_row_loop:
			add edx, eax
			movdqu xmm0, [esi + edx]
			movdqu xmm4, [esi + edx + 1]	;xmm4 = xmm01I
			xmm01I xmm0, xmm4, xmm0, xmm2	;xmm0 = 'xmm0'
			
			movdqu xmm1, [esi + edx + 2]
			xmm01I xmm4, xmm1, xmm1, xmm2	;xmm1 = 'xmm1'
			
			paddb xmm4, xmm0
			paddb xmm4, xmm1				;xmm4 = xmm0 + xmm01I + xmm1
			
			movdqu xmm3, xmm7
			paddb xmm3, xmm6
			paddb xmm3, xmm4				;xmm3 = suma de la grilla
			por xmm3, xmm5					;xmm3 = suma de la grilla | estado de celula
			
			;Reutilizo los xmm que ya tengo
			movdqu xmm7, xmm6
			paddb xmm7, xmm5
			
			movdqu xmm6, xmm0
			paddb xmm6, xmm1
			
			xmm01I xmm0, xmm1, xmm5, xmm2	;xmm5 = xmm01I
			
			;Calculo el estado de cada celula
			pcmpeqb xmm0, xmm0
			psrlw xmm0, 14		;xmm0 = | 3 | x 8
			movdqu xmm1, xmm0
			pslldq xmm1, 1
			por xmm0, xmm1		;xmm0 = | 3 | x 16
			
			pcmpeqb xmm2, xmm2
			psrlw xmm2, 12		;xmm2 = | 15 | x 8
			movdqu xmm1, xmm2
			pslldq xmm1, 1
			por xmm2, xmm1		;xmm2 = | 15 | x 16
			
			movdqu xmm4, xmm2
			pand xmm4, xmm3		;xmm4 = 0 | b30 | 0 | b28 | .. | 0 | b0
			pcmpeqb xmm4, xmm0	;xmm4 = 0 | c30 | 0 | c28 | .. | 0 | c0
			pxor xmm1, xmm1
			psubb xmm1, xmm4
			movdqu xmm4, xmm1
			;pabsb xmm4, xmm4	;xmm4 = 0 | s30 | 0 | s28 | .. | 0 | s0
			
			psrlw xmm3, 4		;xmm3 = 0 | b31 | b30 | b29 | 0 | .. | b2 | b1
			pand xmm2, xmm3		;xmm2 = 0 | b31 | 0 | b29 | .. | 0 | b1
			pcmpeqb xmm2, xmm0	;xmm2 = 0 | c31 | 0 | c29 | .. | 0 | c1
			pxor xmm1, xmm1
			psubb xmm1, xmm2
			movdqu xmm2, xmm1
			;pabsb xmm2, xmm2	;xmm2 = 0 | s31 | 0 | s29 | .. | 0 | s1
			psllw xmm2, 4		;xmm2 = c31 | 0 | c29 | .. | 0 | c1 | 0
			
			por xmm2, xmm4
			movdqu [edi + edx], xmm2
		
		loop .conway_step_row_loop_jmpfar
		jmp .conway_step_row_loop_end
		
	.conway_step_row_loop_jmpfar:
		jmp .conway_step_row_loop
		
	.conway_step_row_loop_end:
		add esi, 16
		add edi, 16
		
		dec dword [cs_var_wid]
	jnz .conway_step_col_loop
	
	mov ecx, esi
	add ecx, 2
	sub ecx, [cs_oldState]
	sub ecx, eax
	jae .conway_step_ret
	
	add ecx, 16
	sub esi, ecx
	sub edi, ecx
	
	mov dword [cs_var_wid], 1
	jmp .conway_step_col_loop
	
.conway_step_ret:
	pop ebx
	pop esi
	pop edi
	add esp, 4
	pop ebp
	ret
	