#include "../../common/utils.h"
#include "idle.h"


#define prt_cmd(cmd, desc) \
	scr_printf("%C* %s - %C%s\n", CYAN, cmd, WHITE, desc);

directory_contents dir_contents[2];
int curr_dir_i = 0;



int getInput(char *buf, int max) {
	int cont = 1;
	int bi = 0;
	int a = 0;

	int tab_e = 0;
	int tab_i = 0;
	int tab_last_entry = -1;
	int tab_reset = 0;

	while (cont) {
		a = 1 - a;
		scr_printf("%c", 8);

		char key = getKeyboardNextChar();
		char code = getKeyboardLastCode();
		if (code != 0) {
			if (key == 8) {
				if (bi > 0) {
					scr_printf("%c", key);
					tab_reset = 1;
					bi --;
				}
			} else if (key == 10) {
				cont = 0;
			} else if (code == 15) {	//Codigo de la tecla TAB
				//Si no tenia fijado un rango, busca el ' ' o ',' mas cercano
				if (tab_reset) {
					tab_e = bi;
					tab_i = bi;
					tab_reset = 0;
					tab_last_entry = -1;
					while (tab_i > 0 && buf[tab_i - 1] != ' ' && buf[tab_i - 1] != ',') tab_i --;
				}

				int found = 0;
				char **it = 0;
				int mustSearchFromBeginning = (tab_last_entry != -1);
				do {
					int entryCount = 0;

					//Busca en directorios
					it = dir_contents[curr_dir_i].dirs;
					while (*it != 0 && entryCount <= tab_last_entry) {
						entryCount ++;
						it ++;
					}
					if (entryCount > tab_last_entry) {
						while (!found && *it != 0) {
							tab_last_entry ++;
							entryCount	++;
							if (strncmp(*it, buf + tab_i, tab_e - tab_i) == 0) {
								found = 1;
							} else {
								it ++;
							}
						}
					}

					//Busca en archivos;
					if (!found) {
						it = dir_contents[curr_dir_i].files;
						while (*it != 0 && entryCount <= tab_last_entry) {
							entryCount ++;
							it ++;
						}
						if (entryCount > tab_last_entry) {
							while (!found && *it != 0) {
								tab_last_entry ++;
								entryCount ++;
								if (strncmp(*it, buf + tab_i, tab_e - tab_i) == 0) {
									found = 1;
								} else {
									it ++;
								}
							}
						}
					}

					if (!found) {
						if (mustSearchFromBeginning) {
							mustSearchFromBeginning = 0;
							tab_last_entry = -1;
						} else {
							break;
						}
					}
				} while (!found);

				//Si encontro algun archivo/directorio que empezara con
				//el substring en rango, lo copia al buffer y lo imprime
				//en pantalla
				if (found) {
					int i = bi;
					strcpy(buf + tab_i, *it);
					bi = tab_i + strlen(*it);

					char del[2] = {8, 0};
					for(; i > tab_i; i--) {
						scr_printf(del);
					}

					for(; i < bi; i++) {
						scr_printf("%c", buf[i]);
					}
				}
			} else {
				if (bi + 1 < max) {
					if (key != 0) {
						scr_printf("%c", key);
						buf[bi ++] = key;
						tab_reset = 1;
					}
				}
			}
		}

		if (a == 0 && cont) {
			scr_printf("_");
		} else {
			scr_printf(" ");
		}
	}

	buf[bi] = 0;
	return bi;
}

char *getPathRelativeTo(const char *path, const char *dir) {
	char *ret;
	int i = strlen(dir);
	if (path[0] == '/') {
		i = 1;
		ret = (char *) malloc(strlen(path) + 2);
		ret[0] = '/';
		ret[1] = 0;
	} else {
		ret = (char *) malloc(i + strlen(path) + 2);
		strcpy(ret, dir);
	}

	//Concatena el path actual con el pasado por parametro,
	//respetando ".."
	int e = -1;
	int cont = 1;
	do {
		do {
			path += e + 1;
			e = indexOf(path, '/');
		} while (e == 0);

		if (e == -1) {
			e = strlen(path);
			cont = 0;
		}

		if (strncmp(path, "..", e) == 0) {
			if (i > 1) {
				i -= 2;
				while (i > 1 && ret[i] != '/')	i --;
			}
		} else {
			if (ret[i - 1] != '/') 	ret[i ++] = '/';
			strncpy(ret + i, path, e);
			i += e;
		}
	} while (cont);
	ret[i] = 0;

	return ret;
}


char dir[256];
char buffer[512];

unsigned int HEI;
void clearScreen() {
	int chars = ((HEI+11) / 12);
	char line[chars+1];
	int i = 0;
	for (; i < chars; i++) line[i] = '\n';
	line[i] = 0;

	scr_xyprintf(0,0, YELLOW, "%s", line);
	scr_xyprintf(0,0, YELLOW, "\tTipear \"help\" para obtener una lista de comandos disponibles.\n"
			"Se puede apretar %CF4%C mientras corren tareas para matarlas y volver a esta consola.\n\n", WHITE, YELLOW);
}

void start() {
	//Shell de comandos
	//WID = getScreenWidth();
	HEI = getScreenHeight();
	clearScreen();
	
	getKeyboardFocus();
	strcpy(dir, "/");

	if (getDirectoryContents(dir, &(dir_contents[curr_dir_i])) != 1) {
		scr_printf("%C<<ERROR AL OBTENER LA INFO DEL DIRECTORIO ROOT>>", RED);
		while (1);
	}

	while (1) {
		scr_printf("%C%s $>  %C", GREEN, dir, WHITE);
		getInput(buffer, 512);
		scr_printf("\n");

		if (strcmp(buffer, "help") == 0) {
			scr_printf("%C[Comandos disponibles]:\n", YELLOW);
			prt_cmd("help", "Muestra esta lista.");
			prt_cmd("ls", "Informa el contenido del directorio actual.");
			prt_cmd("cd [dir]", "Cambia el directorio actual al directorio con path [dir] relativo al actual.");
			prt_cmd("ld [path]", "Carga y transfiere el control a la tarea en [path], relativo al directorio actual.");
			prt_cmd("ld2 [t1], [t2]", "Carga simultaneamente y transfiere el control a las tareas en [t1] y [t2], relativas al directorio actual.");
			prt_cmd("clear", "Limpia la pantalla.");
		} else if (strcmp(buffer, "clear") == 0) {
			clearScreen();
		} else if (strcmp(buffer, "ls") == 0) {
			scr_printf("\t");

			char **it = dir_contents[curr_dir_i].dirs;
			while (*it != 0) {
				scr_printf("%C%s ", GREEN, *it);
				it ++;
			}
			it = dir_contents[curr_dir_i].files;
			while (*it != 0) {
				scr_printf("%C%s ", CYAN, *it);
				it ++;
			}

			scr_printf("\n");
		} else if (strncmp(buffer, "cd ", 3) == 0) {
			char *path = buffer + 2;

			//Le hace un "left trim" al path
			while (*path && *path == ' ') path ++;
			if (*path != 0) {
				char *dir2 = getPathRelativeTo(path, dir);
				int i = strlen(dir2);
				if (dir2[i - 1] != '/') 	dir2[i ++] = '/';
				dir2[i] = 0;

				if (getDirectoryContents(dir2, &(dir_contents[1-curr_dir_i])) != 1) {
					scr_printf("%CEl path resultante '%s' no existe\n", RED, dir2);
				} else {
					releaseDirectoryContentsStruct(&(dir_contents[curr_dir_i]));
					curr_dir_i = 1 - curr_dir_i;
					strcpy(dir, dir2);
				}
				free(dir2);
			}
		} else if (strncmp(buffer, "ld ", 3) == 0) {
			char *path = buffer + 2;

			//Le hace un "left trim" al path
			while (*path && *path == ' ') path ++;
			if (*path != 0) {
				char *file = getPathRelativeTo(path, dir);

				if (runFile(file) != 1) {
					scr_printf("%CEl archivo con path resultante '%s' no existe\n", RED, file);
				} else {
					clearScreen();
				}
				free(file);
			}
		} else if (strncmp(buffer, "ld2 ", 4) == 0) {
			char *path = buffer + 3;

			//Le hace un "left trim" al path
			while (*path && *path == ' ') path ++;
			if (*path != 0) {
				int e = indexOf(path, ',');
				if (e == -1) {
					scr_printf("%CEl comando requiere dos archivos, separados por ','\n", RED);
				} else {
					char* path1 = (char*) malloc(e+1);
					char* path2 = (char*) malloc(strlen(path) - e);
					strncpy(path1, path, e); path1[e] = 0;
					strcpy(path2, path+e+1);
					
					path = path2;
					while (*path && *path == ' ') path ++;
					if (*path != 0) {
						char *f1 = getPathRelativeTo(path1, dir);
						char *f2 = getPathRelativeTo(path, dir);
						if (runFiles(f1, f2) != 1) {
							scr_printf("%CAlguno de los archivos no existe\n", RED);
						} else {
							clearScreen();
						}
						free(f1);
						free(f2);
					}
					free(path1);
					free(path2);
				}
			}
		} else {
			//Ver si los archivos se cargan con comandos o con el nombre
			scr_printf("%CComando desconocido\n", GRAY);
		}
	}
}